/*
        alph: Piper program implementing and analysing traditional and
        historic c(ai)phers designed to be used in conjuction with other
        programs.

        Copyright (C) 2004  Corcalciuc V. Horia

        This library is free software; you can redistribute it and/or
        modify it under the terms of the GNU Lesser General Public
        License as published by the Free Software Foundation; either
        version 2.1 of the License, or (at your option) any later version.

        This library is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
        Lesser General Public License for more details.

        You should have received a copy of the GNU Lesser General Public
        License along with this library; if not, write to the Free Software
        Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

*/

/* Errors */

#define KEYB	2		/* bad key. */
#define ENTO	3		/* entropy too short */
#define UNKN    1		/* unkown fault */

/* Decrypt-Encrypt */

typedef enum
{
  false = 0,
  true
} DoE;

DoE al_dec, al_enc;

/* Cyphers */

extern int caesar (char *org);					  /* CAESAR */
extern int atbash (char *org);					  /* ATBASH */
extern int rot13 (char *org);					  /* ROT-13 */
extern int vigenere (char *org, char *key);			  /* VIGENERE */
extern int vernam (char *org, char *afile);			  /* VERNAM */
extern int playfair (char *org, char *key);			  /* PLAYFAIR */
extern int bifid (char *org, char *key);			  /* BIFID */
int purple(char *org, char *k_six, char *k_fast, char *k_middle, char *k_slow, char *k_mot);   /* PURPLE */
extern int enigma (char *org, char *rot, char *ref, char *ring);  /* ENIGMA */
extern int morse (char *org);					  /* MORSE */
extern int twosquare (char *org, char *key_a, char *key_b);
extern int lewis (char *org, char *key);			  /* LEWIS */
extern int alberti (char *org, char *key);			  /* ALBERTI */
extern int feistel (char *org, char *key);			  /* FEISTEL */
extern int tea (char *org, char *key);            /* TEA */

/* Hashers */

char *encode_base64(int *org);						/*					*/
int *decode_base64(char *org);						/*	BASE64	*/
extern char *base64 (int *org);				  	  	/*					*/
unsigned long unixhash(char *org);        /* LINUX ELF HASH */
char *lfshift(char *org, int size);       /* PERSONAL LINEAR FORWARD SHIFT */
int hashpjw(char *org);                   /* PETER WEINBERGER'S HASH */
unsigned long sdbmh(char *org);           /* SDBM HASH */
unsigned long djb2(char *org);            /* DAN BERNSTEIN */
char XORhash( char *key, int len);        /* XOR HASH */
char *md5hash(char *org);                 /* MD5 */
